## ddnet 11.0.3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8)

file(STRINGS src/game/version.h VERSION_LINE
  LIMIT_COUNT 1
  REGEX GAME_RELEASE_VERSION
)

if(VERSION_LINE MATCHES "\"([0-9]+)\\.([0-9]+)\\.([0-9]+)\"")
  set(VERSION_MAJOR ${CMAKE_MATCH_1})
  set(VERSION_MINOR ${CMAKE_MATCH_2})
  set(VERSION_PATCH ${CMAKE_MATCH_3})
elseif(VERSION_LINE MATCHES "\"([0-9]+)\\.([0-9]+)\"")
  set(VERSION_MAJOR ${CMAKE_MATCH_1})
  set(VERSION_MINOR ${CMAKE_MATCH_2})
  set(VERSION_PATCH "0")
else()
  message(FATAL_ERROR "Couldn't parse version from src/game/version.h")
endif()

if(POLICY CMP0048)
  cmake_policy(SET CMP0048 NEW)
  if(VERSION_PATCH STREQUAL "0")
    project(DDNet VERSION ${VERSION_MAJOR}.${VERSION_MINOR})
  else()
    project(DDNet VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
  endif()
else()
  project(DDNet)
  set(PROJECT_VERSION_MAJOR ${VERSION_MAJOR})
  set(PROJECT_VERSION_MINOR ${VERSION_MINOR})
  set(PROJECT_VERSION_PATCH ${VERSION_PATCH})
  if(VERSION_PATCH STREQUAL "0")
    set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR})
  else()
    set(PROJECT_VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})
  endif()
endif()

set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)

if(CMAKE_SIZEOF_VOID_P EQUAL 8)
  set(TARGET_BITS "64")
elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
  set(TARGET_BITS "32")
endif()

if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
  set(TARGET_OS "windows")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Linux")
  set(TARGET_OS "linux")
elseif(CMAKE_SYSTEM_NAME STREQUAL "Darwin")
  set(TARGET_OS "mac")
endif()

include(CheckCCompilerFlag)
include(CheckCXXCompilerFlag)
include(CheckSymbolExists)

check_symbol_exists(__i386 "" TARGET_ARCH_X86_i386)
if(TARGET_ARCH_X86_i386)
  set(TARGET_ARCH x86)
else()
  set(TARGET_ARCH)
endif()

set(AUTO_DEPENDENCIES_DEFAULT OFF)
if(TARGET_OS STREQUAL "windows")
  set(AUTO_DEPENDENCIES_DEFAULT ON)
endif()

option(WEBSOCKETS "Enable websockets support" OFF)
option(MYSQL "Enable mysql support" OFF)
option(CLIENT "Compile client" ON)
option(DOWNLOAD_GTEST "Download and compile GTest" ${AUTO_DEPENDENCIES_DEFAULT})
option(PREFER_BUNDLED_LIBS "Prefer bundled libraries over system libraries" ${AUTO_DEPENDENCIES_DEFAULT})

# Set the default build type to Release
if(NOT(CMAKE_BUILD_TYPE))
  set(CMAKE_BUILD_TYPE Release)
endif()

set(DBG $<OR:$<CONFIG:Debug>,$<CONFIG:RelWithDebInfo>>)

set_property(DIRECTORY APPEND PROPERTY CMAKE_CONFIGURE_DEPENDS
  src/game/version.h
)

set(SERVER_EXECUTABLE DDNet-Server CACHE STRING "Name of the built server executable")
set(CLIENT_EXECUTABLE DDNet CACHE STRING "Name of the build client executable")

########################################################################
# Compiler flags
########################################################################

function(add_c_compiler_flag_if_supported VARIABLE FLAG)
  if(ARGC GREATER 2)
    set(CHECKED_FLAG "${ARGV2}")
  else()
    set(CHECKED_FLAG "${FLAG}")
  endif()
  string(REGEX REPLACE "[^A-Za-z0-9]" "_" CONFIG_VARIABLE "FLAG_SUPPORTED${CHECKED_FLAG}")
  check_c_compiler_flag("${CHECKED_FLAG}" ${CONFIG_VARIABLE})
  if(${CONFIG_VARIABLE})
    if(${VARIABLE})
      set("${VARIABLE}" "${${VARIABLE}};${FLAG}" PARENT_SCOPE)
    else()
      set("${VARIABLE}" "${FLAG}" PARENT_SCOPE)
    endif()
  endif()
endfunction()

if(NOT MSVC)
  if(CMAKE_VERSION VERSION_LESS 3.1 OR TARGET_OS STREQUAL "mac")
    check_cxx_compiler_flag(-std=gnu++11 FLAG_SUPPORTED_std_gnu__11)
    if(FLAG_SUPPORTED_std_gnu__11)
      if(CMAKE_CXX_FLAGS)
        set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -std=gnu++11")
      else()
        set(CMAKE_CXX_FLAGS -std=gnu++11)
      endif()
    endif()
  endif()

  # Protect the stack pointer.
  # -fstack-protector-all doesn't work on MinGW.
  add_c_compiler_flag_if_supported(OUR_FLAGS -fstack-protector-all)

  # Inaccurate floating point numbers cause problems on mingw-w64-gcc when
  # compiling for x86, might cause problems elsewhere. So don't store floats
  # in registers but keep them at higher accuracy.

  if(TARGET_ARCH STREQUAL "x86")
    add_c_compiler_flag_if_supported(OUR_FLAGS -ffloat-store)
  endif()

  if(TARGET_OS STREQUAL "mac")
    add_c_compiler_flag_if_supported(OUR_FLAGS -stdlib=libc++)
    add_c_compiler_flag_if_supported(OUR_FLAGS -mmacosx-version-min=10.7)
  endif()

  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wall)
  if(CMAKE_VERSION VERSION_GREATER 3.3 OR CMAKE_VERSION VERSION_EQUAL 3.3)
    add_c_compiler_flag_if_supported(OUR_FLAGS_OWN
      $<$<COMPILE_LANGUAGE:C>:-Wdeclaration-after-statement>
      -Wdeclaration-after-statement
    )
  endif()
  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wextra)
  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-unused-parameter)
  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-missing-field-initializers)
  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wformat=2) # Warn about format strings.
endif()

########################################################################
# DEPENDENCIES
########################################################################

function(set_extra_dirs_lib VARIABLE NAME)
  set("PATHS_${VARIABLE}_LIBDIR" PARENT_SCOPE)
  set("HINTS_${VARIABLE}_LIBDIR" PARENT_SCOPE)
  if(PREFER_BUNDLED_LIBS)
    set(TYPE HINTS)
  else()
    set(TYPE PATHS)
  endif()
  if(TARGET_BITS AND TARGET_OS)
    set(DIR "ddnet-libs/${NAME}/${TARGET_OS}/lib${TARGET_BITS}")
    set("${TYPE}_${VARIABLE}_LIBDIR" "${DIR}" PARENT_SCOPE)
    set("EXTRA_${VARIABLE}_LIBDIR" "${DIR}" PARENT_SCOPE)
  endif()
endfunction()

function(set_extra_dirs_include VARIABLE NAME LIBRARY)
  set("PATHS_${VARIABLE}_INCLUDEDIR" PARENT_SCOPE)
  set("HINTS_${VARIABLE}_INCLUDEDIR" PARENT_SCOPE)
  is_bundled(IS_BUNDLED "${LIBRARY}")
  if(IS_BUNDLED)
    set("HINTS_${VARIABLE}_INCLUDEDIR" "ddnet-libs/${NAME}/include" "ddnet-libs/${NAME}/include/${TARGET_OS}" PARENT_SCOPE)
  endif()
endfunction()

if(CMAKE_CROSSCOMPILING)
  set(CROSSCOMPILING_NO_CMAKE_SYSTEM_PATH NO_CMAKE_SYSTEM_PATH)
else()
  set(CROSSCOMPILING_NO_CMAKE_SYSTEM_PATH)
endif()

function(is_bundled VARIABLE PATH)
  if(PATH)
    string(FIND "${PATH}" "${PROJECT_SOURCE_DIR}" LOCAL_PATH_POS)
    if(LOCAL_PATH_POS EQUAL 0 AND TARGET_BITS AND TARGET_OS)
      set("${VARIABLE}" ON PARENT_SCOPE)
    else()
      set("${VARIABLE}" OFF PARENT_SCOPE)
    endif()
  else()
    set("${VARIABLE}" OFF PARENT_SCOPE)
  endif()
endfunction()

if(NOT CMAKE_CROSSCOMPILING)
  # Check for PkgConfig once so all the other `find_package` calls can do it
  # quietly.
  find_package(PkgConfig)
endif()
find_package(Curl)
find_package(Freetype)
if(DOWNLOAD_GTEST)
  find_package(Git)
endif()
find_package(GTest)
if(MYSQL)
  find_package(MySQL)
else()
  set(MYSQL_LIBRARIES)
endif()
find_package(Ogg)
find_package(Opus)
find_package(Opusfile)
find_package(PythonInterp)
find_package(SDL2)
find_package(Threads)
if(NOT PREFER_BUNDLED_LIBS)
  find_package(ZLIB)
else()
  set(ZLIB_FOUND NO)
endif()

if(TARGET_OS AND TARGET_OS STREQUAL "mac")
  find_program(DMG dmg)
  find_program(HFSPLUS hfsplus)
  find_program(NEWFS_HFS newfs_hfs)
  if(DMG AND HFSPLUS AND NEWFS_HFS)
    set(DMGTOOLS_FOUND ON)
  else()
    set(DMGTOOLS_FOUND OFF)
  endif()

  find_program(HDIUTIL hdiutil)
endif()

message(STATUS "******** DDNet ********")
message(STATUS "Target OS: ${TARGET_OS} ${TARGET_BITS}bit")
message(STATUS "Compiler: ${CMAKE_CXX_COMPILER}")
message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")

message(STATUS "Dependencies:")
function(show_dependency_status NAME FOUND PATH)
  if(FOUND)
    is_bundled(IS_BUNDLED "${PATH}")
    if(IS_BUNDLED)
      message(STATUS " * ${NAME} not found (using bundled version)")
    else()
      message(STATUS " * ${NAME} found")
    endif()
  else()
    message(STATUS " * ${NAME} not found")
  endif()
endfunction()

show_dependency_status("Curl" ${CURL_FOUND} "${CURL_LIBRARY}")
if(TARGET_OS AND TARGET_OS STREQUAL "mac")
  show_dependency_status("Dmg tools" ${DMGTOOLS_FOUND} "")
endif()
show_dependency_status("Freetype" ${FREETYPE_FOUND} "${FREETYPE_LIBRARY}")
if(DOWNLOAD_GTEST)
  show_dependency_status("Git" ${GIT_FOUND} "${GIT_EXECUTABLE}")
endif()
show_dependency_status("GTest" ${GTEST_FOUND} "${GTEST_LIBRARY}")
if(TARGET_OS AND TARGET_OS STREQUAL "mac")
  show_dependency_status("Hdiutil" ${HDIUTIL} "")
endif()
if(MYSQL)
  show_dependency_status("MySQL" ${MYSQL_FOUND} "${MYSQL_LIBRARY}")
endif()
show_dependency_status("Ogg" ${OGG_FOUND} "${OGG_INCLUDEDIR}")
show_dependency_status("Opus" ${OPUS_FOUND} "${OPUS_INCLUDEDIR}")
show_dependency_status("Opusfile" ${OPUSFILE_FOUND} "${OPUSFILE_LIBRARY}")
show_dependency_status("PythonInterp" ${PYTHONINTERP_FOUND} "")
show_dependency_status("SDL2" ${SDL2_FOUND} "${SDL2_LIBRARY}")
if(ZLIB_FOUND)
  message(STATUS " * Zlib found")
else()
  message(STATUS " * Zlib not found (using bundled version)")
endif()

if(NOT(PYTHONINTERP_FOUND))
  message(SEND_ERROR "You must install Python to compile DDNet")
endif()

if(MYSQL AND NOT(MYSQL_FOUND))
  message(SEND_ERROR "You must install MySQL to compile the DDNet server with MySQL support")
endif()

if(CLIENT AND NOT(CURL_FOUND))
  message(SEND_ERROR "You must install Curl to compile the DDNet client")
endif()
if(CLIENT AND NOT(FREETYPE_FOUND))
  message(SEND_ERROR "You must install Freetype to compile the DDNet client")
endif()
if(CLIENT AND NOT(OGG_FOUND))
  message(SEND_ERROR "You must install Ogg to compile the DDNet client")
endif()
if(CLIENT AND NOT(OPUS_FOUND))
  message(SEND_ERROR "You must install Opus to compile the DDNet client")
endif()
if(CLIENT AND NOT(OPUSFILE_FOUND))
  message(SEND_ERROR "You must install Opusfile to compile the DDNet client")
endif()
if(CLIENT AND NOT(SDL2_FOUND))
  message(SEND_ERROR "You must install SDL2 to compile the DDNet client")
endif()
if(NOT(GTEST_FOUND))
  if(DOWNLOAD_GTEST)
    if(GIT_FOUND)
      message(STATUS "Automatically downloading GTest to be able to run tests")
    else()
      set(DOWNLOAD_GTEST OFF)
      message(WARNING "To automatically download GTest, you have to install Git")
    endif()
  else()
    message(STATUS "To run the tests, you have to install GTest")
  endif()
endif()

if(TARGET_OS STREQUAL "windows")
  set(PLATFORM_CLIENT)
  set(PLATFORM_CLIENT_LIBS opengl32 glu32 winmm)
  set(PLATFORM_LIBS ws2_32) # Windows sockets
elseif(TARGET_OS STREQUAL "mac")
  find_library(CARBON Carbon)
  find_library(COCOA Cocoa)
  find_library(OPENGL OpenGL)
  find_library(SECURITY Security)
  set(PLATFORM_CLIENT
    src/osx/notification.h
    src/osx/notification.mm
    src/osxlaunch/client.h
    src/osxlaunch/client.m
  )
  set(PLATFORM_CLIENT_LIBS ${COCOA} ${OPENGL} ${SECURITY})
  set(PLATFORM_LIBS ${CARBON})
else()
  set(PLATFORM_CLIENT)
  set(PLATFORM_CLIENT_LIBS GL GLU X11)
  if(TARGET_OS STREQUAL "linux")
    set(PLATFORM_LIBS rt) # clock_gettime for glibc < 2.17
  else()
    set(PLATFORM_LIBS)
  endif()
endif()

if(NOT MSVC)
  check_c_compiler_flag("-O2;-Wp,-Werror;-D_FORTIFY_SOURCE=2" DEFINE_FORTIFY_SOURCE) # Some distributions define _FORTIFY_SOURCE by themselves.
endif()

########################################################################
# DOWNLOAD GTEST
########################################################################

if(NOT(GTEST_FOUND) AND DOWNLOAD_GTEST)
  # Change to the 1.9.0 release tag once that works.
  set(DDNET_GTEST_VERSION 7b6561c56e353100aca8458d7bc49c4e0119bae8)
  configure_file(cmake/Download_GTest_CMakeLists.txt.in googletest-download/CMakeLists.txt)
  execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
    RESULT_VARIABLE result
    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/googletest-download
  )
  if(result)
    message(WARNING "CMake step for googletest failed: ${result}")
    set(DOWNLOAD_GTEST OFF)
  else()
    execute_process(COMMAND ${CMAKE_COMMAND} --build .
      RESULT_VARIABLE result
      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/googletest-download
    )
    if(result)
      message(WARNING "Build step for googletest failed: ${result}")

=== debian/changelog ===
ddnet (11.0.3-1build1) bionic; urgency=medium

  * No-change rebuild against libcurl4

 -- Steve Langasek <steve.langasek@ubuntu.com>  Wed, 28 Feb 2018 06:49:14 +0000

ddnet (11.0.3-1) unstable; urgency=medium

  * New upstream release
  * Fix FTBFS on 32bit architectures (Closes: #890372)
  * Change the location of data directory to upstream favoured one
  * Update copyright
  * Bump Standards-Version to 4.1.3
  * Move Vcs to Salsa platform
  * Bump debhelper compat to v11

 -- Yangfl <mmyangfl@gmail.com>  Wed, 14 Feb 2018 16:49:07 +0800

ddnet (10.8.6-3) unstable; urgency=medium

  * Update copyright

 -- Yangfl <mmyangfl@gmail.com>  Tue, 28 Nov 2017 22:39:25 +0800

ddnet (10.8.6-2) unstable; urgency=medium

  [ Yangfl]
  * Update copyright

  [ SZ Lin (林上智) ]
  * Clean up copyright

 -- SZ Lin (林上智) <szlin@debian.org>  Fri, 29 Sep 2017 10:50:32 +0800

ddnet (10.8.6-1) unstable; urgency=medium

  * Initial release (Closes: #794166)

 -- Yangfl <mmyangfl@gmail.com>  Sat, 16 Sep 2017 21:30:00 +0800

=== debian/control ===
Source: ddnet
Section: games
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
Uploaders:
 Boyuan Yang <073plan@gmail.com>,
 Yangfl <mmyangfl@gmail.com>,
 SZ Lin (林上智) <szlin@debian.org>,
Build-Depends:
 debhelper (>= 11),
Build-Depends-Arch:
 cmake,
 python3,
 libcurl4-openssl-dev,
 libfreetype6-dev,
 libogg-dev,
 libopus-dev,
 libopusfile-dev,
 libsdl2-dev,
 libmariadbclient-dev,
 libmysqlcppconn-dev,
 libboost-dev,
 libglew-dev,
 libpnglite-dev,
 libwavpack-dev,
Build-Depends-Indep:
 icnsutils,
Standards-Version: 4.1.3
Homepage: https://ddnet.tw/
Vcs-Git: https://salsa.debian.org/yangfl-guest/ddnet.git
Vcs-Browser: https://salsa.debian.org/yangfl-guest/ddnet

Package: ddnet
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ddnet-data (= ${source:Version}),
Description: Teeworlds modification with a unique cooperative gameplay
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains the client binary for DDNet.

Package: ddnet-server
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 ddnet-data (= ${source:Version}),
Suggests:
 ddnet-tools,
Description: Server for DDNet
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains the server binary for DDNet.

Package: ddnet-tools
Architecture: any
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
Description: Tools for DDNet
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains tools for DDNet maps and configs.

Package: ddnet-data
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
Recommends:
 fonts-dejavu-core,
 fonts-wqy-microhei,
Description: Data for DDNet
 DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
 modification with a unique cooperative gameplay. Help each other play through
 custom maps with up to 64 players, compete against the best in international
 tournaments, design your own maps, or run your own server.
 .
 This package contains the static data for DDNet.

=== debian/rules ===
#!/usr/bin/make -f
#export DH_VERBOSE = 1


export DEB_BUILD_MAINT_OPTIONS = hardening=+all

export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed


%:
	dh $@

build-indep:
	# pass

override_dh_clean-arch:
	dh_clean -a
	$(RM) DDNet*.png

override_dh_auto_configure-arch:
	dh_auto_configure -a -- \
		-DMYSQL=ON -DWEBSOCKETS=ON -DPREFER_BUNDLED_LIBS=OFF

override_dh_auto_install-arch:
	cd obj-$(DEB_BUILD_GNU_TYPE) && DESTDIR=$(CURDIR)/debian/tmp cmake -DCOMPONENT=portable -P cmake_install.cmake

override_dh_install-indep:
	dh_install -i
	for f in languages/license.txt languages/scripts; do \
		rm -rf "debian/ddnet-data/usr/share/games/ddnet/data/$$f"; \
	done
	for exe in DDNet; do \
		icns2png -x other/icons/$${exe}.icns; \
		for px in 16 32 48 128 256 512; do \
			size=$${px}x$${px}; \
			fn=$${exe}_$${size}x32.png; \
			if [ -f $${fn} ]; then \
				dir=debian/ddnet-data/usr/share/icons/hicolor/$${size}/apps/; \
				mkdir -p $${dir}; \
				mv $${fn} $${dir}/$${exe}.png; \
			fi; \
		done; \
	done

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ddnet-$1.tar.gz%" \
 https://github.com/ddnet/ddnet/tags \
 (?:.*?/)?v?(\d[\d.]*)\.tar\.gz debian uupdate

## ddnet 11.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -36,7 +36,11 @@
   endif()
 endif()
 
-set(CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
+set(ORIGINAL_CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH})
+set(ORIGINAL_CMAKE_REQUIRED_INCLUDES ${CMAKE_REQUIRED_INCLUDES})
+set(ORIGINAL_CMAKE_REQUIRED_LIBRARIES ${CMAKE_REQUIRED_LIBRARIES})
+set(OWN_CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
+set(CMAKE_MODULE_PATH ${OWN_CMAKE_MODULE_PATH})
 
 if(CMAKE_SIZEOF_VOID_P EQUAL 8)
   set(TARGET_BITS "64")
@@ -149,7 +153,61 @@
   add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-unused-parameter)
   add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-missing-field-initializers)
   add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wformat=2) # Warn about format strings.
-endif()
+  add_c_compiler_flag_if_supported(OUR_FLAGS_DEP -Wno-implicit-function-declaration)
+endif()
+
+if(NOT MSVC)
+  check_c_compiler_flag("-O2;-Wp,-Werror;-D_FORTIFY_SOURCE=2" DEFINE_FORTIFY_SOURCE) # Some distributions define _FORTIFY_SOURCE by themselves.
+endif()
+
+########################################################################
+# COMMON FUNCTIONS
+########################################################################
+
+function(set_glob VAR GLOBBING DIRECTORY) # ...
+  file(${GLOBBING} GLOB_RESULT "${DIRECTORY}/*.c" "${DIRECTORY}/*.cpp" "${DIRECTORY}/*.h")
+  list(SORT GLOB_RESULT)
+  set(FILES)
+  foreach(file ${ARGN})
+    list(APPEND FILES "${PROJECT_SOURCE_DIR}/${DIRECTORY}/${file}")
+  endforeach()
+
+  if(NOT FILES STREQUAL GLOB_RESULT)
+    message(AUTHOR_WARNING "${VAR} does not contain every file from directory ${DIRECTORY}")
+    set(LIST_BUT_NOT_GLOB)
+    if(POLICY CMP0057)
+      cmake_policy(SET CMP0057 NEW)
+      foreach(file ${FILES})
+        if(NOT file IN_LIST GLOB_RESULT)
+          list(APPEND LIST_BUT_NOT_GLOB ${file})
+        endif()
+      endforeach()
+      if(LIST_BUT_NOT_GLOB)
+        message(AUTHOR_WARNING "Entries only present in ${VAR}: ${LIST_BUT_NOT_GLOB}")
+      endif()
+      set(GLOB_BUT_NOT_LIST)
+      foreach(file ${GLOB_RESULT})
+        if(NOT file IN_LIST FILES)
+          list(APPEND GLOB_BUT_NOT_LIST ${file})
+        endif()
+      endforeach()
+      if(GLOB_BUT_NOT_LIST)
+        message(AUTHOR_WARNING "Entries only present in ${DIRECTORY}: ${GLOB_BUT_NOT_LIST}")
+      endif()
+    endif()
+  endif()
+
+  set(${VAR} ${FILES} PARENT_SCOPE)
+endfunction()
+
+########################################################################
+# INITIALIZE TARGET LISTS
+########################################################################
+
+set(TARGETS_OWN)
+set(TARGETS_DEP)
+
+set(TARGETS_LINK) # Targets with a linking stage.
 
 ########################################################################
 # DEPENDENCIES
@@ -203,11 +261,14 @@
   # quietly.
   find_package(PkgConfig)
 endif()
+find_package(ZLIB)
+find_package(Crypto)
 find_package(Curl)
 find_package(Freetype)
 if(DOWNLOAD_GTEST)
   find_package(Git)
 endif()
+find_package(GLEW)
 find_package(GTest)
 if(MYSQL)
   find_package(MySQL)
@@ -217,14 +278,18 @@
 find_package(Ogg)
 find_package(Opus)
 find_package(Opusfile)
+find_package(Pnglite)
 find_package(PythonInterp)
 find_package(SDL2)
 find_package(Threads)
-if(NOT PREFER_BUNDLED_LIBS)
-  find_package(ZLIB)
-else()
-  set(ZLIB_FOUND NO)
-endif()
+find_package(Wavpack)
+if(WEBSOCKETS)
+  find_package(Websockets)
+else()
+  set(WEBSOCKETS_LIBRARIES)
+  set(WEBSOCKETS_INCLUDE_DIRS)
+endif()
+
 
 if(TARGET_OS AND TARGET_OS STREQUAL "mac")
   find_program(DMG dmg)
@@ -245,45 +310,50 @@
 message(STATUS "Build type: ${CMAKE_BUILD_TYPE}")
 
 message(STATUS "Dependencies:")
-function(show_dependency_status NAME FOUND PATH)
-  if(FOUND)
-    is_bundled(IS_BUNDLED "${PATH}")
-    if(IS_BUNDLED)
-      message(STATUS " * ${NAME} not found (using bundled version)")
+function(show_dependency_status OUTPUT_NAME NAME)
+  if(${NAME}_FOUND)
+    if(${NAME}_BUNDLED)
+      message(STATUS " * ${OUTPUT_NAME} not found (using bundled version)")
     else()
-      message(STATUS " * ${NAME} found")
-    endif()
-  else()
-    message(STATUS " * ${NAME} not found")
-  endif()
-endfunction()
-
-show_dependency_status("Curl" ${CURL_FOUND} "${CURL_LIBRARY}")
+      message(STATUS " * ${OUTPUT_NAME} found")
+    endif()
+  else()
+    message(STATUS " * ${OUTPUT_NAME} not found")
+  endif()
+endfunction()
+
+show_dependency_status("Curl" CURL)
 if(TARGET_OS AND TARGET_OS STREQUAL "mac")
-  show_dependency_status("Dmg tools" ${DMGTOOLS_FOUND} "")
-endif()
-show_dependency_status("Freetype" ${FREETYPE_FOUND} "${FREETYPE_LIBRARY}")
+  show_dependency_status("Dmg tools" DMGTOOLS)
+endif()
+show_dependency_status("Freetype" FREETYPE)
 if(DOWNLOAD_GTEST)
-  show_dependency_status("Git" ${GIT_FOUND} "${GIT_EXECUTABLE}")
-endif()
-show_dependency_status("GTest" ${GTEST_FOUND} "${GTEST_LIBRARY}")
+  show_dependency_status("Git" GIT)
+endif()
+show_dependency_status("Glew" GLEW)
+show_dependency_status("GTest" GTEST)
 if(TARGET_OS AND TARGET_OS STREQUAL "mac")
-  show_dependency_status("Hdiutil" ${HDIUTIL} "")
+  show_dependency_status("Hdiutil" HDIUTIL)
 endif()
 if(MYSQL)
-  show_dependency_status("MySQL" ${MYSQL_FOUND} "${MYSQL_LIBRARY}")
-endif()
-show_dependency_status("Ogg" ${OGG_FOUND} "${OGG_INCLUDEDIR}")
-show_dependency_status("Opus" ${OPUS_FOUND} "${OPUS_INCLUDEDIR}")
-show_dependency_status("Opusfile" ${OPUSFILE_FOUND} "${OPUSFILE_LIBRARY}")
-show_dependency_status("PythonInterp" ${PYTHONINTERP_FOUND} "")
-show_dependency_status("SDL2" ${SDL2_FOUND} "${SDL2_LIBRARY}")
-if(ZLIB_FOUND)
-  message(STATUS " * Zlib found")
-else()
-  message(STATUS " * Zlib not found (using bundled version)")
-endif()
-
+  show_dependency_status("MySQL" MYSQL)
+endif()
+show_dependency_status("Ogg" OGG)
+show_dependency_status("OpenSSL Crypto" CRYPTO)
+show_dependency_status("Opus" OPUS)
+show_dependency_status("Opusfile" OPUSFILE)
+show_dependency_status("Pnglite" PNGLITE)
+show_dependency_status("PythonInterp" PYTHONINTERP)
+show_dependency_status("SDL2" SDL2)
+show_dependency_status("Wavpack" WAVPACK)
+show_dependency_status("Zlib" ZLIB)
+if(WEBSOCKETS)
+  show_dependency_status("Websockets" WEBSOCKETS)
+endif()
+
+if(NOT(CURL_FOUND))
+  message(SEND_ERROR "You must install Curl to compile the DDNet")
+endif()
 if(NOT(PYTHONINTERP_FOUND))
   message(SEND_ERROR "You must install Python to compile DDNet")
 endif()
@@ -292,9 +362,10 @@
   message(SEND_ERROR "You must install MySQL to compile the DDNet server with MySQL support")
 endif()
 
-if(CLIENT AND NOT(CURL_FOUND))
-  message(SEND_ERROR "You must install Curl to compile the DDNet client")
-endif()
+if(WEBSOCKETS AND NOT(WEBSOCKETS_FOUND))
+  message(SEND_ERROR "You must install libwebsockets to compile the DDNet server with websocket support")
+endif()
+
 if(CLIENT AND NOT(FREETYPE_FOUND))
   message(SEND_ERROR "You must install Freetype to compile the DDNet client")
 endif()
@@ -310,69 +381,3 @@
 if(CLIENT AND NOT(SDL2_FOUND))
   message(SEND_ERROR "You must install SDL2 to compile the DDNet client")
 endif()
-if(NOT(GTEST_FOUND))
-  if(DOWNLOAD_GTEST)
-    if(GIT_FOUND)
-      message(STATUS "Automatically downloading GTest to be able to run tests")
-    else()
-      set(DOWNLOAD_GTEST OFF)
-      message(WARNING "To automatically download GTest, you have to install Git")
-    endif()
-  else()
-    message(STATUS "To run the tests, you have to install GTest")
-  endif()
-endif()
-
-if(TARGET_OS STREQUAL "windows")
-  set(PLATFORM_CLIENT)
-  set(PLATFORM_CLIENT_LIBS opengl32 glu32 winmm)
-  set(PLATFORM_LIBS ws2_32) # Windows sockets
-elseif(TARGET_OS STREQUAL "mac")
-  find_library(CARBON Carbon)
-  find_library(COCOA Cocoa)
-  find_library(OPENGL OpenGL)
-  find_library(SECURITY Security)
-  set(PLATFORM_CLIENT
-    src/osx/notification.h
-    src/osx/notification.mm
-    src/osxlaunch/client.h
-    src/osxlaunch/client.m
-  )
-  set(PLATFORM_CLIENT_LIBS ${COCOA} ${OPENGL} ${SECURITY})
-  set(PLATFORM_LIBS ${CARBON})
-else()
-  set(PLATFORM_CLIENT)
-  set(PLATFORM_CLIENT_LIBS GL GLU X11)
-  if(TARGET_OS STREQUAL "linux")
-    set(PLATFORM_LIBS rt) # clock_gettime for glibc < 2.17
-  else()
-    set(PLATFORM_LIBS)
-  endif()
-endif()
-
-if(NOT MSVC)
-  check_c_compiler_flag("-O2;-Wp,-Werror;-D_FORTIFY_SOURCE=2" DEFINE_FORTIFY_SOURCE) # Some distributions define _FORTIFY_SOURCE by themselves.
-endif()
-
-########################################################################
-# DOWNLOAD GTEST
-########################################################################
-
-if(NOT(GTEST_FOUND) AND DOWNLOAD_GTEST)
-  # Change to the 1.9.0 release tag once that works.
-  set(DDNET_GTEST_VERSION 7b6561c56e353100aca8458d7bc49c4e0119bae8)
-  configure_file(cmake/Download_GTest_CMakeLists.txt.in googletest-download/CMakeLists.txt)
-  execute_process(COMMAND ${CMAKE_COMMAND} -G "${CMAKE_GENERATOR}" .
-    RESULT_VARIABLE result
-    WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/googletest-download
-  )
-  if(result)
-    message(WARNING "CMake step for googletest failed: ${result}")
-    set(DOWNLOAD_GTEST OFF)
-  else()
-    execute_process(COMMAND ${CMAKE_COMMAND} --build .
-      RESULT_VARIABLE result
-      WORKING_DIRECTORY ${CMAKE_BINARY_DIR}/googletest-download
-    )
-    if(result)
-      message(WARNING "Build step for googletest failed: ${result}")

=== debian/changelog ===
ddnet (11.3.1-1) unstable; urgency=medium

  * New upstream release
  * d/watch: Update upstream URL

 -- Yangfl <mmyangfl@gmail.com>  Wed, 15 Aug 2018 13:38:26 +0800

ddnet (11.2.1-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Wed, 04 Jul 2018 00:17:11 +0800

ddnet (11.1.8-1) unstable; urgency=medium

  * New upstream release
  * Temporarily bundle icon font since it uses Unicode private area

 -- Yangfl <mmyangfl@gmail.com>  Thu, 24 May 2018 14:26:39 +0800

ddnet (11.1.3-1) unstable; urgency=medium

  * New upstream release
  * Move data location to usr/share/games/ddnet/data/
  * Update copyright
  * Bump Standards-Version to 4.1.4
  * Move Vcs to Team repo

 -- Yangfl <mmyangfl@gmail.com>  Mon, 09 Apr 2018 10:55:12 +0800

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,13 @@
 Source: ddnet
 Section: games
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
+Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
  Boyuan Yang <073plan@gmail.com>,
  Yangfl <mmyangfl@gmail.com>,
  SZ Lin (林上智) <szlin@debian.org>,
 Build-Depends:
- debhelper (>= 11),
+ debhelper (>= 11~),
 Build-Depends-Arch:
  cmake,
  python3,
@@ -24,19 +23,20 @@
  libglew-dev,
  libpnglite-dev,
  libwavpack-dev,
+ libwebsockets-dev,
 Build-Depends-Indep:
  icnsutils,
-Standards-Version: 4.1.3
+Standards-Version: 4.1.4
 Homepage: https://ddnet.tw/
-Vcs-Git: https://salsa.debian.org/yangfl-guest/ddnet.git
-Vcs-Browser: https://salsa.debian.org/yangfl-guest/ddnet
+Vcs-Git: https://salsa.debian.org/games-team/ddnet.git
+Vcs-Browser: https://salsa.debian.org/games-team/ddnet
 
 Package: ddnet
 Architecture: any
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
- ddnet-data (= ${source:Version}),
+ ddnet-data (>= ${source:Version}),
 Description: Teeworlds modification with a unique cooperative gameplay
  DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds
  modification with a unique cooperative gameplay. Help each other play through
@@ -50,7 +50,7 @@
 Depends:
  ${shlibs:Depends},
  ${misc:Depends},
- ddnet-data (= ${source:Version}),
+ ddnet-data (>= ${source:Version}),
 Suggests:
  ddnet-tools,
 Description: Server for DDNet
@@ -79,8 +79,8 @@
 Multi-Arch: foreign
 Depends:
  ${misc:Depends},
+ fonts-dejavu-core,
 Recommends:
- fonts-dejavu-core,
  fonts-wqy-microhei,
 Description: Data for DDNet
  DDraceNetwork (DDNet) is an actively maintained version of DDRace, a Teeworlds

=== debian/rules ===
--- 
+++ 
@@ -14,13 +14,16 @@
 build-indep:
 	# pass
 
-override_dh_clean-arch:
-	dh_clean -a
+override_dh_clean-indep:
+	dh_clean -i
 	$(RM) DDNet*.png
 
 override_dh_auto_configure-arch:
 	dh_auto_configure -a -- \
 		-DMYSQL=ON -DWEBSOCKETS=ON -DPREFER_BUNDLED_LIBS=OFF
+
+override_dh_auto_build-arch:
+	dh_auto_build -a
 
 override_dh_auto_install-arch:
 	cd obj-$(DEB_BUILD_GNU_TYPE) && DESTDIR=$(CURDIR)/debian/tmp cmake -DCOMPONENT=portable -P cmake_install.cmake
@@ -28,7 +31,7 @@
 override_dh_install-indep:
 	dh_install -i
 	for f in languages/license.txt languages/scripts; do \
-		rm -rf "debian/ddnet-data/usr/share/games/ddnet/data/$$f"; \
+		rm -r "debian/ddnet-data/usr/share/games/ddnet/data/$$f"; \
 	done
 	for exe in DDNet; do \
 		icns2png -x other/icons/$${exe}.icns; \

## ddnet 11.4.2

=== debian/changelog ===
ddnet (11.4.2-2) unstable; urgency=medium

  * Team upload.
  * Bump Standards-Version to 4.2.1.
  * Remove myself from uploaders list.

 -- Boyuan Yang <byang@debian.org>  Wed, 29 Aug 2018 10:52:15 -0400

ddnet (11.4.2-1) unstable; urgency=medium

  * New upstream release
  * Remove statically linked libgcc and libstdc++
  * Bump Standards-Version to 4.2.0

 -- Yangfl <mmyangfl@gmail.com>  Sat, 25 Aug 2018 14:53:10 +0800

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,6 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders:
- Boyuan Yang <073plan@gmail.com>,
  Yangfl <mmyangfl@gmail.com>,
  SZ Lin (林上智) <szlin@debian.org>,
 Build-Depends:
@@ -26,7 +25,7 @@
  libwebsockets-dev,
 Build-Depends-Indep:
  icnsutils,
-Standards-Version: 4.1.4
+Standards-Version: 4.2.1
 Homepage: https://ddnet.tw/
 Vcs-Git: https://salsa.debian.org/games-team/ddnet.git
 Vcs-Browser: https://salsa.debian.org/games-team/ddnet

=== debian/rules ===
--- 
+++ 
@@ -30,7 +30,7 @@
 
 override_dh_install-indep:
 	dh_install -i
-	for f in languages/license.txt languages/scripts; do \
+	for f in languages/license.txt; do \
 		rm -r "debian/ddnet-data/usr/share/games/ddnet/data/$$f"; \
 	done
 	for exe in DDNet; do \

## ddnet 11.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -68,19 +68,29 @@
 endif()
 
 set(AUTO_DEPENDENCIES_DEFAULT OFF)
+set(AUTOUPDATE_DEFAULT OFF)
 if(TARGET_OS STREQUAL "windows")
   set(AUTO_DEPENDENCIES_DEFAULT ON)
+  set(AUTOUPDATE_DEFAULT ON)
+elseif(TARGET_OS STREQUAL "linux")
+  set(AUTOUPDATE_DEFAULT ON)
 endif()
 
 option(WEBSOCKETS "Enable websockets support" OFF)
 option(MYSQL "Enable mysql support" OFF)
+option(AUTOUPDATE "Enable the autoupdater" ${AUTOUPDATE_DEFAULT})
 option(CLIENT "Compile client" ON)
 option(DOWNLOAD_GTEST "Download and compile GTest" ${AUTO_DEPENDENCIES_DEFAULT})
 option(PREFER_BUNDLED_LIBS "Prefer bundled libraries over system libraries" ${AUTO_DEPENDENCIES_DEFAULT})
+option(DEV "Don't generate stuff necessary for packaging" OFF)
 
 # Set the default build type to Release
 if(NOT(CMAKE_BUILD_TYPE))
-  set(CMAKE_BUILD_TYPE Release)
+  if(NOT(DEV))
+    set(CMAKE_BUILD_TYPE Release)
+  else()
+    set(CMAKE_BUILD_TYPE Debug)
+  endif()
 endif()
 
 set(DBG $<OR:$<CONFIG:Debug>,$<CONFIG:RelWithDebInfo>>)
@@ -372,12 +382,3 @@
 if(CLIENT AND NOT(OGG_FOUND))
   message(SEND_ERROR "You must install Ogg to compile the DDNet client")
 endif()
-if(CLIENT AND NOT(OPUS_FOUND))
-  message(SEND_ERROR "You must install Opus to compile the DDNet client")
-endif()
-if(CLIENT AND NOT(OPUSFILE_FOUND))
-  message(SEND_ERROR "You must install Opusfile to compile the DDNet client")
-endif()
-if(CLIENT AND NOT(SDL2_FOUND))
-  message(SEND_ERROR "You must install SDL2 to compile the DDNet client")
-endif()

=== debian/changelog ===
ddnet (11.5-1) unstable; urgency=medium

  * New upstream release
  * Disable tests that require network (Closes: #913487)

 -- Yangfl <mmyangfl@gmail.com>  Sun, 18 Nov 2018 14:09:40 +0800

ddnet (11.4.6-1) unstable; urgency=medium

  * New upstream release
  * Enable gtest and add build dep libgtest-dev
  * Add build dep libmd-dev and add use-system-libmd.patch
  * Add autopkgtest

 -- Yangfl <mmyangfl@gmail.com>  Mon, 05 Nov 2018 12:55:20 +0800

=== debian/control ===
--- 
+++ 
@@ -17,12 +17,14 @@
  libopusfile-dev,
  libsdl2-dev,
  libmariadbclient-dev,
+ libmd-dev (>= 1.0.1),
  libmysqlcppconn-dev,
  libboost-dev,
  libglew-dev,
  libpnglite-dev,
  libwavpack-dev,
  libwebsockets-dev,
+ libgtest-dev,
 Build-Depends-Indep:
  icnsutils,
 Standards-Version: 4.2.1

=== debian/rules ===
--- 
+++ 
@@ -4,7 +4,7 @@
 
 export DEB_BUILD_MAINT_OPTIONS = hardening=+all
 
-export DEB_CFLAGS_MAINT_APPEND  = -Wall -pedantic
+export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -O3
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
 
 
@@ -20,13 +20,19 @@
 
 override_dh_auto_configure-arch:
 	dh_auto_configure -a -- \
-		-DMYSQL=ON -DWEBSOCKETS=ON -DPREFER_BUNDLED_LIBS=OFF
+		-DMYSQL=ON -DWEBSOCKETS=ON -DPREFER_BUNDLED_LIBS=OFF \
+		-DTEST_ARGS=--gtest_filter=-Jobs.LookupHost
 
 override_dh_auto_build-arch:
 	dh_auto_build -a
 
+override_dh_auto_test-arch:
+	+cd obj-$(DEB_BUILD_GNU_TYPE) && make run_tests
+
 override_dh_auto_install-arch:
 	cd obj-$(DEB_BUILD_GNU_TYPE) && DESTDIR=$(CURDIR)/debian/tmp cmake -DCOMPONENT=portable -P cmake_install.cmake
+
+override_dh_auto_install-indep:
 
 override_dh_install-indep:
 	dh_install -i

## ddnet 11.6

=== debian/changelog ===
ddnet (11.6-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Mon, 24 Dec 2018 21:46:03 +0800

=== debian/control ===
--- 
+++ 
@@ -16,7 +16,7 @@
  libopus-dev,
  libopusfile-dev,
  libsdl2-dev,
- libmariadbclient-dev,
+ libmariadb-dev,
  libmd-dev (>= 1.0.1),
  libmysqlcppconn-dev,
  libboost-dev,

=== debian/rules ===
--- 
+++ 
@@ -6,6 +6,14 @@
 
 export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -O3
 export DEB_LDFLAGS_MAINT_APPEND = -Wl,--as-needed
+
+include /usr/share/dpkg/architecture.mk
+
+ifeq ($(DEB_HOST_ARCH),ia64)
+  # gcc o3 segfault on ia64
+  # It's just annoying, not a sign I'll care about ia64
+  export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
+endif
 
 
 %:
@@ -17,6 +25,7 @@
 override_dh_clean-indep:
 	dh_clean -i
 	$(RM) DDNet*.png
+	$(RM) -r datasrc/*.pyc datasrc/__pycache__
 
 override_dh_auto_configure-arch:
 	dh_auto_configure -a -- \

## ddnet 11.7.2

=== debian/changelog ===
ddnet (11.7.2-2) unstable; urgency=medium

  * Fix FTBFS on architectures where char is unsigned (Closes: #921443)
  * Disable autoupdater

 -- Yangfl <mmyangfl@gmail.com>  Tue, 12 Feb 2019 22:31:43 +0800

ddnet (11.7.2-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.3.0
  * Bump debhelper compat to 12

 -- Yangfl <mmyangfl@gmail.com>  Tue, 29 Jan 2019 14:39:54 +0800

## ddnet 11.8

=== CMakeLists.txt ===
--- 
+++ 
@@ -361,8 +361,8 @@
   show_dependency_status("Websockets" WEBSOCKETS)
 endif()
 
-if(NOT(CURL_FOUND))
-  message(SEND_ERROR "You must install Curl to compile the DDNet")
+if(CLIENT AND NOT(CURL_FOUND))
+  message(SEND_ERROR "You must install Curl to compile DDNet")
 endif()
 if(NOT(PYTHONINTERP_FOUND))
   message(SEND_ERROR "You must install Python to compile DDNet")

=== debian/changelog ===
ddnet (11.8-1) unstable; urgency=medium

  * New upstream release

 -- Yangfl <mmyangfl@gmail.com>  Tue, 26 Feb 2019 23:31:36 +0800

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Yangfl <mmyangfl@gmail.com>,
  SZ Lin (林上智) <szlin@debian.org>,
 Build-Depends:
- debhelper (>= 11~),
+ debhelper (>= 12~),
 Build-Depends-Arch:
  cmake,
  python3,
@@ -27,7 +27,7 @@
  libgtest-dev,
 Build-Depends-Indep:
  icnsutils,
-Standards-Version: 4.2.1
+Standards-Version: 4.3.0
 Homepage: https://ddnet.tw/
 Vcs-Git: https://salsa.debian.org/games-team/ddnet.git
 Vcs-Browser: https://salsa.debian.org/games-team/ddnet

=== debian/rules ===
--- 
+++ 
@@ -29,8 +29,8 @@
 
 override_dh_auto_configure-arch:
 	dh_auto_configure -a -- \
-		-DMYSQL=ON -DWEBSOCKETS=ON -DPREFER_BUNDLED_LIBS=OFF \
-		-DTEST_ARGS=--gtest_filter=-Jobs.LookupHost
+		-DMYSQL=ON -DWEBSOCKETS=ON -DPREFER_BUNDLED_LIBS=OFF -DAUTOUPDATE=OFF \
+		-DTESTRUNNER_ARGS=--gtest_filter=-Jobs.LookupHost
 
 override_dh_auto_build-arch:
 	dh_auto_build -a

## ddnet 12.5

=== CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 
 file(STRINGS src/game/version.h VERSION_LINE
   LIMIT_COUNT 1
-  REGEX GAME_RELEASE_VERSION
+  REGEX "^#define GAME_RELEASE_VERSION "
 )
 
 if(VERSION_LINE MATCHES "\"([0-9]+)\\.([0-9]+)\\.([0-9]+)\"")
@@ -84,6 +84,8 @@
 option(PREFER_BUNDLED_LIBS "Prefer bundled libraries over system libraries" ${AUTO_DEPENDENCIES_DEFAULT})
 option(DEV "Don't generate stuff necessary for packaging" OFF)
 
+set(OpenGL_GL_PREFERENCE LEGACY)
+
 # Set the default build type to Release
 if(NOT(CMAKE_BUILD_TYPE))
   if(NOT(DEV))
@@ -91,6 +93,10 @@
   else()
     set(CMAKE_BUILD_TYPE Debug)
   endif()
+endif()
+
+if(NOT(CMAKE_BUILD_TYPE MATCHES "^(Release|Debug|RelWithDebInfo|MinSizeRel)$"))
+  message(WARNING "Unknown CMAKE_BUILD_TYPE, should be one of Release, Debug, RelWithDebInfo or MinSizeRel")
 endif()
 
 set(DBG $<OR:$<CONFIG:Debug>,$<CONFIG:RelWithDebInfo>>)
@@ -122,6 +128,13 @@
     endif()
   endif()
 endfunction()
+
+# Force compiler colors on when using ninja. Ninja filters the colors out when
+# it's not printing to a terminal on its own.
+if(CMAKE_GENERATOR STREQUAL "Ninja")
+  add_c_compiler_flag_if_supported(OUR_FLAGS -fdiagnostics-color=always)
+  add_c_compiler_flag_if_supported(OUR_FLAGS -fcolor-diagnostics)
+endif()
 
 if(NOT MSVC)
   if(CMAKE_VERSION VERSION_LESS 3.1 OR TARGET_OS STREQUAL "mac")
@@ -164,6 +177,12 @@
   add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wno-missing-field-initializers)
   add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wformat=2) # Warn about format strings.
   add_c_compiler_flag_if_supported(OUR_FLAGS_DEP -Wno-implicit-function-declaration)
+  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wduplicated-cond)
+  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wduplicated-branches)
+  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wlogical-op)
+  add_c_compiler_flag_if_supported(OUR_FLAGS_OWN -Wrestrict)
+  # TODO: Enable for C++ code except gtest
+  #add_cxx_compiler_flag_if_supported(OUR_FLAGS_OWN "-Wuseless-cast")
 endif()
 
 if(NOT MSVC)
@@ -204,6 +223,9 @@
       if(GLOB_BUT_NOT_LIST)
         message(AUTHOR_WARNING "Entries only present in ${DIRECTORY}: ${GLOB_BUT_NOT_LIST}")
       endif()
+      if(NOT LIST_BUT_NOT_GLOB AND NOT GLOB_BUT_NOT_LIST)
+        message(AUTHOR_WARNING "${VAR} is not alphabetically sorted")
+      endif()
     endif()
   endif()
 
@@ -274,7 +296,7 @@
 find_package(ZLIB)
 find_package(Crypto)
 find_package(Curl)
-find_package(Freetype)
+find_package(OwnFreetype)
 if(DOWNLOAD_GTEST)
   find_package(Git)
 endif()
@@ -350,35 +372,3 @@
 endif()
 show_dependency_status("Ogg" OGG)
 show_dependency_status("OpenSSL Crypto" CRYPTO)
-show_dependency_status("Opus" OPUS)
-show_dependency_status("Opusfile" OPUSFILE)
-show_dependency_status("Pnglite" PNGLITE)
-show_dependency_status("PythonInterp" PYTHONINTERP)
-show_dependency_status("SDL2" SDL2)
-show_dependency_status("Wavpack" WAVPACK)
-show_dependency_status("Zlib" ZLIB)
-if(WEBSOCKETS)
-  show_dependency_status("Websockets" WEBSOCKETS)
-endif()
-
-if(CLIENT AND NOT(CURL_FOUND))
-  message(SEND_ERROR "You must install Curl to compile DDNet")
-endif()
-if(NOT(PYTHONINTERP_FOUND))
-  message(SEND_ERROR "You must install Python to compile DDNet")
-endif()
-
-if(MYSQL AND NOT(MYSQL_FOUND))
-  message(SEND_ERROR "You must install MySQL to compile the DDNet server with MySQL support")
-endif()
-
-if(WEBSOCKETS AND NOT(WEBSOCKETS_FOUND))
-  message(SEND_ERROR "You must install libwebsockets to compile the DDNet server with websocket support")
-endif()
-
-if(CLIENT AND NOT(FREETYPE_FOUND))
-  message(SEND_ERROR "You must install Freetype to compile the DDNet client")
-endif()
-if(CLIENT AND NOT(OGG_FOUND))
-  message(SEND_ERROR "You must install Ogg to compile the DDNet client")
-endif()

=== debian/changelog ===
ddnet (12.5-2) unstable; urgency=medium

  * Team upload.
  * debian/control: Bump Standards-Version to 4.4.0.
  * debian/compat: Removed, not needed.

  [ Gianfranco Costamagna ]
  * Allow stderr in autopkgtest due to new gcc-9 deprecated
    copy warnings.

 -- Boyuan Yang <byang@debian.org>  Tue, 03 Sep 2019 13:46:03 -0400

ddnet (12.5-1) unstable; urgency=medium

  * New upstream release
  * Updata manpages, thanks to Ryozuki <ryo@ryozuki.xyz>

 -- Yangfl <mmyangfl@gmail.com>  Thu, 04 Jul 2019 16:38:09 +0800

=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
  Yangfl <mmyangfl@gmail.com>,
  SZ Lin (林上智) <szlin@debian.org>,
 Build-Depends:
- debhelper (>= 12~),
+ debhelper-compat (= 12),
 Build-Depends-Arch:
  cmake,
  python3,
@@ -17,7 +17,6 @@
  libopusfile-dev,
  libsdl2-dev,
  libmariadb-dev,
- libmd-dev (>= 1.0.1),
  libmysqlcppconn-dev,
  libboost-dev,
  libglew-dev,
@@ -27,7 +26,7 @@
  libgtest-dev,
 Build-Depends-Indep:
  icnsutils,
-Standards-Version: 4.3.0
+Standards-Version: 4.4.0
 Homepage: https://ddnet.tw/
 Vcs-Git: https://salsa.debian.org/games-team/ddnet.git
 Vcs-Browser: https://salsa.debian.org/games-team/ddnet

=== debian/tests/control ===
Tests: unittest.sh
Depends: @builddeps@
Restrictions: allow-stderr

## ddnet 12.7.2

=== debian/changelog ===
ddnet (12.7.2-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.4.1

 -- Yangfl <mmyangfl@gmail.com>  Wed, 23 Oct 2019 13:12:23 +0800

=== debian/control ===
--- 
+++ 
@@ -26,7 +26,7 @@
  libgtest-dev,
 Build-Depends-Indep:
  icnsutils,
-Standards-Version: 4.4.0
+Standards-Version: 4.4.1
 Homepage: https://ddnet.tw/
 Vcs-Git: https://salsa.debian.org/games-team/ddnet.git
 Vcs-Browser: https://salsa.debian.org/games-team/ddnet

## ddnet 12.9.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -42,10 +42,10 @@
 set(OWN_CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${PROJECT_SOURCE_DIR}/cmake)
 set(CMAKE_MODULE_PATH ${OWN_CMAKE_MODULE_PATH})
 
-if(CMAKE_SIZEOF_VOID_P EQUAL 8)
+if(CMAKE_SIZEOF_VOID_P EQUAL 4)
+  set(TARGET_BITS "32")
+else()
   set(TARGET_BITS "64")
-elseif(CMAKE_SIZEOF_VOID_P EQUAL 4)
-  set(TARGET_BITS "32")
 endif()
 
 if(CMAKE_SYSTEM_NAME STREQUAL "Windows")
@@ -79,6 +79,7 @@
 option(WEBSOCKETS "Enable websockets support" OFF)
 option(MYSQL "Enable mysql support" OFF)
 option(AUTOUPDATE "Enable the autoupdater" ${AUTOUPDATE_DEFAULT})
+option(VIDEORECORDER "Enable video recording support via FFmpeg" OFF)
 option(CLIENT "Compile client" ON)
 option(DOWNLOAD_GTEST "Download and compile GTest" ${AUTO_DEPENDENCIES_DEFAULT})
 option(PREFER_BUNDLED_LIBS "Prefer bundled libraries over system libraries" ${AUTO_DEPENDENCIES_DEFAULT})
@@ -193,8 +194,12 @@
 # COMMON FUNCTIONS
 ########################################################################
 
-function(set_glob VAR GLOBBING DIRECTORY) # ...
-  file(${GLOBBING} GLOB_RESULT "${DIRECTORY}/*.c" "${DIRECTORY}/*.cpp" "${DIRECTORY}/*.h")
+function(set_glob VAR GLOBBING EXTS DIRECTORY) # ...
+  set(GLOBS)
+  foreach(ext ${EXTS})
+    list(APPEND GLOBS "${DIRECTORY}/*.${ext}")
+  endforeach()
+  file(${GLOBBING} GLOB_RESULT ${GLOBS})
   list(SORT GLOB_RESULT)
   set(FILES)
   foreach(file ${ARGN})
@@ -232,6 +237,11 @@
   set(${VAR} ${FILES} PARENT_SCOPE)
 endfunction()
 
+function(set_src VAR GLOBBING DIRECTORY) # ...
+  set_glob(${VAR} ${GLOBBING} "c;cpp;h" ${DIRECTORY} ${ARGN})
+  set(${VAR} ${${VAR}} PARENT_SCOPE)
+endfunction()
+
 ########################################################################
 # INITIALIZE TARGET LISTS
 ########################################################################
@@ -313,6 +323,9 @@
 find_package(Pnglite)
 find_package(PythonInterp)
 find_package(SDL2)
+if(VIDEORECORDER)
+  find_package(FFmpeg)
+endif()
 find_package(Threads)
 find_package(Wavpack)
 if(WEBSOCKETS)
@@ -334,6 +347,11 @@
   endif()
 
   find_program(HDIUTIL hdiutil)
+  if(HDIUTIL)
+    set(HDIUTIL_FOUND ON)
+  else()
+    set(HDIUTIL_FOUND OFF)
+  endif()
 endif()
 
 message(STATUS "******** DDNet ********")
@@ -359,16 +377,3 @@
   show_dependency_status("Dmg tools" DMGTOOLS)
 endif()
 show_dependency_status("Freetype" FREETYPE)
-if(DOWNLOAD_GTEST)
-  show_dependency_status("Git" GIT)
-endif()
-show_dependency_status("Glew" GLEW)
-show_dependency_status("GTest" GTEST)
-if(TARGET_OS AND TARGET_OS STREQUAL "mac")
-  show_dependency_status("Hdiutil" HDIUTIL)
-endif()
-if(MYSQL)
-  show_dependency_status("MySQL" MYSQL)
-endif()
-show_dependency_status("Ogg" OGG)
-show_dependency_status("OpenSSL Crypto" CRYPTO)

=== debian/changelog ===
ddnet (12.9.2-1ubuntu1) focal; urgency=medium

  * Lower optimization level on s390x to fix a build failure
  * allow stderr because of s390x warnings

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 26 Feb 2020 14:45:06 +0100

ddnet (12.9.2-1) unstable; urgency=medium

  * New upstream release
  * Bump Standards-Version to 4.5.0
  * Add upstream metadata

 -- Yangfl <mmyangfl@gmail.com>  Wed, 26 Feb 2020 00:08:26 +0800

=== debian/control ===
--- 
+++ 
@@ -26,7 +26,8 @@
  libgtest-dev,
 Build-Depends-Indep:
  icnsutils,
-Standards-Version: 4.4.1
+Rules-Requires-Root: no
+Standards-Version: 4.5.0
 Homepage: https://ddnet.tw/
 Vcs-Git: https://salsa.debian.org/games-team/ddnet.git
 Vcs-Browser: https://salsa.debian.org/games-team/ddnet

=== debian/rules ===
--- 
+++ 
@@ -15,6 +15,9 @@
   export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic
 endif
 
+ifeq ($(DEB_HOST_ARCH),s390x)
+  export DEB_CXXFLAGS_MAINT_APPEND = -Wall -pedantic -O1
+endif
 
 %:
 	dh $@

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%ddnet-$1.tar.gz%" \
   https://ddnet.tw/downloads/ \
   DDNet-(\d[\d.]*)\.tar\.xz debian uupdate
